/**
 * 
 */
package com.example.server.webservice;

import javax.annotation.PostConstruct;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.jws.HandlerChain;
import javax.jws.WebMethod;
import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.context.support.SpringBeanAutowiringSupport;

import com.example.server.model.RemoteAccount;
import com.example.server.service.RemoteService;

/**
 * @author PradeepBadiger
 *
 */
@WebService(serviceName="RemoteAccountWebService")
@HandlerChain(file = "jaxws-handlers-server.xml")
@SOAPBinding(style = SOAPBinding.Style.RPC)
@TransactionAttribute(TransactionAttributeType.MANDATORY)
public class RemoteAccountWebService implements IRemoteAccountWebService {

	
	private static final Logger LOGGER = Logger.getLogger(RemoteAccountWebService.class);
	
	@Autowired
	private RemoteService remoteService;

	@PostConstruct
	public void init() {
		SpringBeanAutowiringSupport.processInjectionBasedOnCurrentContext(this);
	}
	
	@WebMethod
	public String saveAccountRecord(String accountNumber, int amount,
			String clientTransactionId, String testCaseId) {
		LOGGER.info("Web method 'saveAccountRecord' called with test case id '"+testCaseId+"' )");
		
		// Enlist the participant for Durable two phase commit.
		/*TransactionManager transactionManager = TransactionManagerFactory.transactionManager();
		RemoteAccountParticipant remoteAccountParticipant = new RemoteAccountParticipant(clientTransactionId);
		
		try {
			transactionManager.enlistForDurableTwoPhase(remoteAccountParticipant, "remoteAccountParticipant:" + UUID.randomUUID());
		} catch (WrongStateException e) {
			LOGGER.error(e);
		} catch (UnknownTransactionException e) {
			LOGGER.error(e);
		} catch (SystemException e) {
			LOGGER.error(e);
		}*/
		
		RemoteAccount record = new RemoteAccount(accountNumber, amount, clientTransactionId);
		record = remoteService.saveRecord(record, testCaseId);
		
		return "SUCCESS";
	}
}
